/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 * 
 * Revision : Fevrurary 2014

 */
package tablePixel;

import java.awt.Color;
import java.awt.Component;
import java.awt.image.Raster;
import javax.swing.*;
import javax.swing.table.DefaultTableCellRenderer;
import javax.swing.table.DefaultTableModel;
import javax.swing.table.JTableHeader;
import javax.swing.table.TableCellRenderer;
import javax.swing.table.TableColumn;


/**
 * Reading a matrix of Pixels
 *   @author dimitri
 *   @see dimitri.pianeta@gmail.com
 */
public class TablePixelDislay extends JFrame {

    
    
     private int h, w; 
    /**
     * Creates new form TablePixel
     */
    public TablePixelDislay(Raster image) {
       int valuePixel[][]  = extractData(image);
            TablePixelDislay(valuePixel);
        
    }
    
    
    
    
    /**
     * Display Table Pixel with lattrice
     * @param value 
     */
  public void TablePixelDislay(int value[][]) {
        JFrame frame = new JFrame("Table Pixel");//Create JFrame
        JPanel panel = new JPanel();//Create JPanel
        int h = value.length; // Rows
        int w = value[0].length;// columns

        String[] col = new String[w];
       

        final String[] rows = new String[h];
        
        for (int i = 0; i < w; i++) {

            col[i] = String.valueOf(i);//columns

        }

        for (int i = 0; i < h; i++) {
            rows[i] = String.valueOf(i);//Rows
        }

        //Transformation matrice
        String[][] value2 = new String[h][6];
        int i = 0;
        while (i < h) {
            value2[i][5] = rows[i];
            i++;
        }

        //Translate value
        String[][] value3 = new String[h][w];

        for (int y = 0; y < w; y++) {
            for (int x = 0; x < h; x++) {
                value3[x][y] = String.valueOf(value[x][y]);
              

            }
        }

// create Table 
        DefaultTableModel dtm = new DefaultTableModel(value3, col);
        JTable table = new JTable(dtm);

        DefaultTableCellRenderer renderer = new DefaultTableCellRenderer();
        renderer.setHorizontalAlignment(SwingConstants.CENTER);

        table.getTableHeader().setReorderingAllowed(false);//lock colonne
        table.getTableHeader().setResizingAllowed(false);
        for (int r = 0; r < w; r++) {
            table.getColumnModel().getColumn(r).setPreferredWidth(29);//dimiension cells
            TableColumn col3 = table.getColumnModel().getColumn(r);// Permit of center of text in cells
            col3.setCellRenderer(renderer);
        }

        JTableHeader rowsheader = table.getTableHeader();
        rowsheader.setBackground(Color.yellow);
      table.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);



// Gestion of JScrollPane
        JScrollPane pane = new JScrollPane(panel); 

        pane.setViewportView(table);
       
        
        ListModel lm = new AbstractListModel() {

            String headers[] = rows;

            public int getSize() {
                return headers.length;
            }

            public Object getElementAt(int index) {
                return headers[index];
            }
        };
        JList rowHeader = new JList(lm);

        rowHeader.setCellRenderer(new RowHeaderRenderer(table));
        rowHeader.setFixedCellHeight(16);
        pane.setRowHeaderView(rowHeader);

        frame.add(pane);

        frame.setSize(500, 500);
        frame.setUndecorated(true);
        frame.getRootPane().setWindowDecorationStyle(JRootPane.PLAIN_DIALOG);
        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        frame.setVisible(true);

    }

   
    
        /**
         * Extraction PixelData
         * @param raster of dicom
         * @return
         */
      private int[][] extractData(Raster raster) {
       // int w = image.getWidth();
       // int h = image.getHeight();
         w = raster.getWidth();
         h = raster.getHeight();

        System.out.printf("w = %d  h = %d%n", w, h);
        //WritableRaster raster = (WritableRaster) getMyImage();
        int[][] data = new int[h][w];
        for (int y = 0; y <h; y++) {
            for (int x = 0; x < w; x++) {
                data[y][x] =raster.getSample(x, y, 0);
              
            }
        }
        return data;
    }

 
  

}
