/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package org.dicom;

import java.io.File;
import java.io.IOException;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JProgressBar;
import org.dcm4che3.data.Attributes;
import org.dcm4che3.data.Tag;
import org.dcm4che3.data.VR;
import org.dcm4che3.io.DicomEncodingOptions;
import org.dcm4che3.io.DicomInputStream;
import org.dcm4che3.io.DicomOutputStream;
import org.dcm4che3.util.SafeClose;

/**
 * Trier un répertoire dicom et rentre anonyme un fichier/ sort a folder dicom and put anonymous a file 
 * @author Dimitri
 * @see dimitri.pianeta@gmail.com
 */
public final class Anomysed {
     public String fileInput, valueFinal; 
         private static Attributes fmi, attr;
         public JProgressBar progressBar; 
        public File file2; 
        private Boolean un ; 
       private DicomEncodingOptions encOpts = DicomEncodingOptions.DEFAULT;

    /**
     *  Constructeur/ Build
     * @param fileRep
     * @param fileoutputRep
     */
    public Anomysed(File fileRep, File fileoutputRep){
       File fS[] = listeRepertoire(fileRep); 
       int noofiles =  numberFile(fileRep); 
             
      
        for(int i=0; i<noofiles; i++){
                   
            
            fileInput = fS[i].getName();               
            fileoutputRep.mkdir(); 
            
            valueFinal = tagSeriesDescription(fS[i]); 
            
            
      file2 = new File(fileoutputRep + "\\"+valueFinal); 
      
         
        file2.mkdir();
            
        anomysed(fS[i], new File(file2.toString() + "\\"+ fileInput) ); 
                  
        }
               setFinish(true); 
                
                
       
        
        
        
    }
    
    
    public void setFinish(Boolean un){
        
        this.un = un; 
    }
   
    public Boolean getFinish(){
        return un; 
    }
    /**
 * Donne la liste des fichiers répertoires/List files of folder
 * @param folder : Folder input
 * @return
 */
public File[] listeRepertoire (File folder){
	System.out.println(folder.getAbsolutePath());
	if(folder.isDirectory()){
		File[] list = folder.listFiles();
		return list;
	}
	return null;
}
    
    
    //Calcul le nombre fichier dans le repertoire / Calculate numbers files in a folder 
public static int numberFile (File folder){
	int nb = 0 ;
	 if ( folder.isDirectory ( ) ) {

	                File[] list = folder.listFiles();
	                if (list != null){               
	                	 nb = list.length;
	                	 return nb;

	                } else {
	                	System.err.println(folder + " : Erreur de lecture.");

	                }
	        }
	return nb;
} 

/**
     *  Read metadata of Dicom 3.0
     * @param f : input file
     * @return Attributes
     * @throws IOException 
     */
    private static Attributes loadDicomObject(File f) throws IOException {
        if (f == null)
            return null;
        DicomInputStream dis = new DicomInputStream(f);
    fmi = dis.getFileMetaInformation();
              attr = dis.readDataset(-1,-1); 
        
        
        try {
            return attr;
        } finally {
            SafeClose.close(dis);
        }
    }


    /**
     * Read tag series description
     * @param inputFile
     * @return 
     */
    private static String tagSeriesDescription(File inputFile){
         try { 
             Attributes  attr= loadDicomObject(inputFile);
             return attr.getString(Tag.SeriesDescription,0); 
             
             
         } catch (IOException ex) {
             Logger.getLogger(Anomysed.class.getName()).log(Level.SEVERE, null, ex);
         }
         return null;
        
        
        
    }
    
    /**
     * Anonymous of Dicom 
     * @param inputFile
     * @param outputFile 
     */
    private void anomysed(File inputFile, File outputFile){
          
            
         try { 
             
          attr= loadDicomObject(inputFile);
                    attr.setString(org.dcm4che3.data.Tag.PatientName,attr.getVR(Tag.PatientName),"anomysed"); 
                    attr.setString(org.dcm4che3.data.Tag.PatientBirthDate,attr.getVR(Tag.PatientBirthDate),"anomysed"); 
             
         } catch (IOException ex) {
             Logger.getLogger(Anomysed.class.getName()).log(Level.SEVERE, null, ex);
         }
         try {
             
             
               DicomOutputStream dos = new DicomOutputStream(outputFile); 
        dos.setEncodingOptions(encOpts);
        dos.writeDataset(fmi, attr);
        dos.finish();
        dos.flush();
        
        
         } catch (IOException ex) {
             Logger.getLogger(Anomysed.class.getName()).log(Level.SEVERE, null, ex);
         }
                 
    }

  
}
